<template>
  <div class="appField">
    <div class="appField-wrapper">
      <div class="ui input">
        <input
          :type="type"
          :name="name"
          :placeholder="placeholder"
          v-model="value"
          @input="onInput">
      </div>
    </div>
  </div>
</template>

<script>
import Vue from 'vue';
import {
  get,
  debounce,
} from 'lodash-es';
import SimpleVueValidation from 'simple-vue-validator';
import Validator from '~/assets/js/validator';

const SimpleVueValidator = SimpleVueValidation.Validator;

Vue.use(SimpleVueValidation, {
  mode: 'conservative',
});

export default {
  name: 'AppField',
  props: {
    type: {
      type: String,
      default: '',
    },
    name: {
      type: String,
      default: '',
    },
    placeholder: {
      type: String,
      default: '',
    },
    revalidate: {
      type: Boolean,
      default: false,
    },
    field: {
      type: Object,
      default() { return {}; },
    },
    validationRule: {
      type: Object,
      default() { return {}; },
    },
  },
  data() {
    return {
      value: get(this.field, 'name', ''),
      error: '',
    };
  },
  validators: {
    value(input) {
      return SimpleVueValidator
        .value(input)
        .custom(() => {
          if (!input) {
            this.$emit('has-error', 'Контакт не может быть пустым');
            return 'Контакт не может быть пустым';
          }

          if (Validator.checkMessengers(this.field)) {
            this.$emit('has-error', 'Некорректное значение поля');
            return 'Некорректное значение поля';
          }

          if (this.validationRule.isUnique) {
            this.debouncedCheckUniqueAdditionalContact();
          }

          this.$emit('has-error', '');
          return false;
        });
    },
  },
  watch: {
    revalidate() {
      this.$validate('value');
    },
  },
  created() {
    this.debouncedCheckUniqueAdditionalContact = debounce(this.checkUniqueAdditionalContact, 500);
  },
  methods: {
    onInput() {
      this.$emit('change-field', this.value);
    },
    checkUniqueAdditionalContact() {
      return this.$axios
        .$get('/_main/user/checkUniqueAdditionalContact', {
          params: {
            contact: this.field.name,
            contactTypeId: this.field.type.id,
            ...this.additionalInformationRequest,
          },
        })
        .then(({ data }) => {
          if (!data) {
            this.$emit('has-error', 'Контакт уже используется');
          }
        })
        .catch(e => console.error(e));
    },
  },
};
</script>

<style scoped lang="scss">
  .appField {
    display: inline-flex;
    width: 100%;
    font-size: .8125rem;
    font-weight: 400;
    font-style: normal;
    color: #272727;

    &.invalid {
      & input {
        border-color: #e13c3c !important;
      }
    }
  }

  .appField-wrapper {
    width: 100%;
  }
</style>
